'******************************************************************************
' VmuxXxX_V35   8x8 Vkreuzschienen Steuerung                         01.07.17 *
'******************************************************************************
' - erste laufende Version fr Audiomischer Umbau auf Video
'----------------------------------------------------------------------------
' - V35   identisch mit 34TT, nur Namensnderung
'----------------------------------------------------------------------------
' - V34_TT  vom Tomtom Encoder Drehrichtungsnderung dazu
'---------------------------------------------------------------------------
' - V34  .. und dazu noch "96bitausgabe" sonst wird der MAX nicht umgeschaltet
'---------------------------------------------------------------------------
' - V33:  Nach Standard_laden UND Standard_setzen auch Erste_Zeile, dann
'         wird auch ohne Reset auf dem LCD korrekt angezeigt
'-------------------------------------------------------------------------
' - V32:   DEBUG zum Timing
'         "1.Zeile" nur einmal, dann nur nderung einzeln anzeigen
'--------------------------------------------------------------------------
'  - V31a Versuche zum LCD "berlauf" beim starten (Wait/ms)
'--------------------------------------------------------------------------
'* - V31: Musterbertragung raus, jetzt an V20 angelehnt
'         0 1 * = Standard laden (aus EEProm)
'         0 0 * = Muster als (neuen) Standard speichern (im EEProm)
'--------------------------------------------------------------------------
'* - V30: Videostandard an jetzige Konfiguration angepat
'__________________________________________________________________________
'* - V25: Standard an DVB-T Betrieb angepat
'--------------------------------------------------------------------------
'* - V24: Standard gendert: Im Quad auf Platz 4 XUM statt XZR
'--------------------------------------------------------------------------
'* - V23: Auf V19 aufsetzend = OHNE Mustereingabe aber OHNE EEProm
'         Standardbelegung wie V22
'--------------------------------------------------------------------------
'* - V22: Das Ganze OHNE EEProm !!
'*        Videostandard mit Horst abgesprochen
'--------------------------------------------------------------------------
'* - V21x: wie Audio 21x2: Mustereingabe komplett mit "{" als Ankndigung
'          Muster Speichern wieder raus
'--------------------------------------------------------------------------
'* - V20: (wieder) mit Standardkonfiguration als Standard 2 speichern
'         0 1 * = Standard laden (wie bisher)
'         0 * * = Muster speichern (neu)
'         0 2 * = Muster laden (neu)
' - Video-Standard wieder angepat
'----------------------------------------------------------------------------
'* - V19: Standard gendert wg. ITV Dauerbetrieb und 9er-Teiler
'         UND I2C Pins auf 0 (= ohne pullup)
' ############### am Anfang immer Standard laden ########################
'--------------------------------------------------------------------------
'* - V18: Standard gendert wegen genderter VMux-Verschaltung
'--------------------------------------------------------------------------
'* - V17: Startup mit EEProm, wenn leer(255): Standard laden (Daten_1)
'--------------------------------------------------------------------------
'* - V16 = V15 OHNE Standard 2. Im EEProm beim Brennen Standard 1, spter
'          immer letzte Konfiguration; Standard 1 (DATA) nur bei Aufruf
'--------------------------------------------------------------------------
'* - V15  = V10a + genderte Vmatrix-Verschaltung
'--------------------------------------------------------------------------
'* - V10a: ISR gendert (jetzt wie AMUX)
'--------------------------------------------------------------------------
'* - V10: Wahlweise Einzelabfrage oder kompletten Status auf einmal
'**************************************************************************
'* - V09: mit 1 Standardkonfiguration und Abspeichern der aktuellen
'         Konfiguration als 2
'         Auswertung der empfangenen bytes in separater Sub
'
'    Eingabe gendert: Eingabe-, dann Ausgabekanal (wie Amux) NICHT -1 !
'    Eingabe jetzt 3 bytes; 3. byte = Schalter (nur 0, 1,* und #)
'    Zeichen:  DTMF    PR        Byte zum slave
'              0-9     0-9       0-9
'              A-D     10-13     10-13
'              *       *         128
'              #       #         129
'**************************************************************************
'* - V08: falls I2C Befehl: Matrix laden unabhngig von Cursorposition
'         manueller Befehl: nur laden, wenn Cursor wieder in 2. Zeile
'**************************************************************************
'* - V07: OSCCAL byte aus "Calibration 3" des Chip-Memory
'*   Bei Initialisierung Interrupts erst am Ende einschalten um Probleme
'*   des LCD Displays zu vermeiden.
'**************************************************************************
'* - Kanalwahl mit Encoder per Int0 (in/out Wahl mit Encoder-Taste)       *
'*   UND  .... NUR wenn Cursor in unterer Zeile (Ausgnge)
'*   WENN Cursor oben wird Eingang an Ausgang 16 "geschickt" ("Vorschau") *
'*   und zwar per "Mode 0"
'*   per I2C-Bus: 2 Bytes: Byte 1 = Ausgang, Byte 2 = Eingang GENDERT
'*   Nach I2C-Eingabe wird 1. LCD Zeile neu geschrieben
'    UND Matrix neu geladen (Mode 1)
'    UND Eeprom "upgedated"
'                                                                         *
'**************************************************************************
'* - Kanalnummern (in and out) bei "1" beginnend
'    Masterbyte dazu +1 (setzen) oder -1 (lesen) ab V08x NICHT mehr
'* - Auslesen eines Videoausgangs per "Twi_master_needs_Byte"                                                                       *
'* - Status aller 16 OUT IN Kanle auf dem LCD
'* - ARRAY (Chout(i)) : Position = Channel out, Inhalt = Channel in       *
'* - Eeprom liefert Startzuordnung und wird laufend "upgedated"
'**************************************************************************
'*  2x16 LCD:  upperline = Eingabekanle  /  lowerline = Ausgabekanle    *
'*  Bei Encoderbetrieb: Cursor in der Zeile deren Werte gendert werden   *
'*  (durch I/O toggling)                                                  *
'**************************************************************************

'**************************************************************************
'*Allgemeine Definitionen
'**************************************************************************
$regfile = "M168def.dat"
'$regfile = "M8def.dat"
$crystal = 8000000                                ' interner RC-Oszillator
$baud = 115200

Debug OFF                                         ' nur zum debuggen

$framesize = 32                                   '
$swstack = 32                                     '
$hwstack = 32                                     '

'**************************************************************************
'* LCD-Einstellungen
'**************************************************************************
Config Lcdpin = Pin , Rs = Portb.0 , E = Portb.1 , Db4 = Portb.2 , Db5 = Portb.3 , Db6 = Portb.4 , Db7 = Portb.5
Config Lcdbus = 4
Config Lcd = 16x2

'**************************************************************************
'* TWI Slave config
'**************************************************************************
Config Twislave = &H62 , Btr = 16 , Bitrate = 100000       ' Adresse = 98 / bis 16 bytes abrufbar / 100kHz
$lib "i2c_twi.lbx"                                ' ist Teil der "i2cslave.lib"
Config Scl = Portc.5                              '
Config Sda = Portc.4
Portc.5 = 0
Portc.4 = 0

'**************************************************************************
'* Port config: C.4 und C.5 fr i2c slave freigehalten / Layout vom Herwig
'**************************************************************************
Config Portc = &B0000_0111                        ' 0 - 2 output
Clk Alias Portc.0                                 ' 4094 Pin 3
Dat Alias Portc.1                                 ' 4094 Pin 2
Strb Alias Portc.2                                ' 4094 Pin 1

Config Portd = &B1100_0011                        ' alle input auer D.6
Portd = &B1011_1111                               ' pullups einschalten

Richtung Alias Pind.3                             ' Schalter am Encoder
Updown Alias Pind.4                               ' Encoder Pin B
                                                  ' Pind.2 (INT0)  fr Encoder "A"
Config Int0 = Change                              ' an Pind.2 auf Flanke warten

'*************************************************************************
'* Variable
'*************************************************************************
Dim I As Byte , N As Byte                         ' Zhlvariable
Dim V As Byte                                     ' Index fr Videomatrix/Array
Dim Chout(16) As Byte                             ' Ausgangskanalnummer
Dim Chout_asc As Byte                             ' als Ascii Zahl
Dim Chout_disp As String * 2                      ' zur LCD Darstellung
'Dim Ch_ein(16) As Word                            ' Ausgangswerte zu CH_ein(n)
Dim Inout As Bit                                  ' Flag fr Input(1) / Output(0)
Dim Z As Byte                                     ' Displayzeile

Dim Outdat As Word                                ' fr shiftout zum Mux

Dim Masterbyte As Byte                            ' fr TWI slave
Dim Chin As Byte
Dim Schalter As Byte                              ' 3. byte per I2C ist Schalter
Dim Byte_count As Byte                            ' count bytes received as slave

Dim Neue_daten As Byte                            ' flag fr 3 bytes vom Master

Dim Plus As Bit                                   ' als Interrupt flags
Dim Minus As Bit                                  '

Dim Xmalx As Byte                                 ' Umschaltung fr 8x8 oder 16x16 zur Laufzeit
Dim Drehrichtung As Byte                          ' Umschaltung der Drehrichtung zur Laufzeit


'*************************************************************************
'* Defaultwerte zur Initialisierung der Eingabekanle
Dta:
$eeprom
Data 0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 , 9 , 10 , 11 , 12 , 13 , 14 , 15 , 16
$data
'*************************************************************************


'*************************************************************************
'* Initialisierung:
'*************************************************************************
'$sim                                              ' Debug

'Umschaltung 8x8 oder 16x16
Readeeprom Xmalx , 100
if Xmalx  > 100 Then
   Xmalx = 8
   Writeeeprom Xmalx , 100
end if
If Richtung = 0 Then
   Select Case Xmalx
      Case 8
         Xmalx = 16
      Case 16
         Xmalx = 8
      Case Else
         Xmalx = 16
   End Select
   Writeeeprom Xmalx , 100
   LCD  Xmalx
   LCD  " mal "
   LCD  Xmalx
   wait 3
   Cls
End If

'Umschaltung Drehrichtung
Readeeprom Drehrichtung , 101
if Drehrichtung  > 100 Then
   Drehrichtung = 1
   Writeeeprom Drehrichtung , 101
end if
If Richtung = 0 Then
   Toggle Drehrichtung.0
   Writeeeprom Drehrichtung , 101
   lcd "Drehrichtungswechsel"
   wait 3
End If

Cls
Cursor Off
Lcd "VXxX_V35"
Debug "VXxX_V35"                                  ' I'm alive !
Wait 2

Byte_count = 0                                    ' zhlt empfangene bytes
Inout = 0
Z = 2                                             ' Cursor Zeile 2
I = 1                                             ' ... und Position 1
Cls
Lowerline
Lcd "1234567890123456"                            ' sind die Ausgabekanle 1-16
Home

Gosub Standard_laden                              ' jetzt aus EEPROM
Gosub 256bitausgabe1                              ' und jetzt zum chip
Gosub Erste_zeile

On Int0 Isr0                                      ' bei Flankenwechsel zur Auswertung der Richtung
Enable Int0                                       ' Encoder Auswertung
Enable Interrupts                                 ' fr Encoder und TWI

'*************************************************************************
'* Hauptprogramm:
'*************************************************************************
I = 1                                             ' Position in der LCD-Zeile
Cursor On Blink
Locate Z , I                                      ' Chout blinkt
Do                                                ' Falls Tasten statt Encoder
   Debounce Richtung , 0 , Einaus , Sub           ' Pind.3 / toggle Eingabe/Ausgabe
   If Plus = 1 Then Gosub Plusplus                ' Auswertung der Interrupt flags
   If Minus = 1 Then Gosub Minusminus
   If Neue_daten = 1 Then Gosub Daten_auswertung  ' Auswertung der 3 neuen bytes

   'Gosub Twi_gotdata                              ' DEBUG  DDDDDDDDDDDDDDDDDDDDDDDD
Loop
End
'*************************************************************************
'* 3 neue Bytes vom Master empfangen                                        ????????????????????????????????????
'*************************************************************************
Daten_auswertung:
   Neue_daten = 0                                 ' flag zurcksetzen

   If Schalter = 1 Then                           ' Knoten setzen
      Gosub Neu_i2c
   Elseif Chin = 0 And Schalter = 128 Then        '  * --> 128
      Select Case I
         Case 0
            Gosub Standard_speichern              ' ---> Sub
            Gosub Erste_zeile                     ' NNNNNNNNNNNNNNNNNNNNNNNNNNNNNN
            Gosub 256bitausgabe1                   ' ????????????????NNNNNNNNNNNNNNNNNNNN?????????????
         Case 1                                   '
            Gosub Standard_laden                  ' ----> Sub
            Gosub Erste_zeile                     ' NNNNNNNNNNNNNNNNNNNNNNNNN
            Gosub 256bitausgabe1                   ' ?????????????????????NNNNNNNNNNNNNNNNNN???????????????

      End Select
   End If

Return
'*************************************************************************
'* I2C hat neue Daten
'*************************************************************************
Neu_i2c:
   Gosub 256bitausgabe1                           ' Matrix laden, unabhngig von Cursorposition
                                                  ' .... aber nicht mehr "Erste_zeile"
   Locate 1 , I                                   '
   If Chout(i) > 9 Then
      Chout_asc = Chout(i) + 55                   ' in Ascii Buchstaben wandeln
   Else
      Chout_asc = Chout(i) + 48                   ' in Ascii Zahl wandeln
   End If
   Chout_disp = Chr(chout_asc)                    ' in Char wandeln
   Lcd Chout_disp

   Locate 2 , I

'   Gosub Erste_zeile                              '... und auf den Display UND Matrix laden
Return

'*************************************************************************
'* Tasten/Encoder - Auswertungen  (fr Handbetrieb)
'*************************************************************************
Plusplus:
   If Inout = 0 Then
      Incr I
      If I > XmalX Then I = 1
      Locate Z , I                                '
   Else
      Incr Chout(i)
      If Chout(i) > XmalX Then Chout(i) = 1          ' berlauf fr 16x16
      Locate Z , I

      If Chout(i) > 9 Then
         Chout_asc = Chout(i) + 55                ' in Ascii Buchstaben wandeln
      Else
         Chout_asc = Chout(i) + 48                ' in Ascii Zahl wandeln
      End If
      Chout_disp = Chr(chout_asc)                 ' in Char wandeln

      Lcd Chout_disp
      Locate Z , I
      Gosub 256Vorschau                           ' "Vorschau" auf Ausgang 16
      Gosub 256bitausgabe0                        ' update abhngig von Cursorposition
   End If
   Plus = 0                                       ' Flag zurcksetzen
Return

Minusminus:
   If Inout = 0 Then
      Decr I
      If I < 1 Then I = XmalX
      Locate Z , I                                '
   Else
      Decr Chout(i)
      If Chout(i) < 1 Then Chout(i) = XmalX          ' berlauf fr 16x16
      Locate Z , I                                '
      If Chout(i) > 9 Then
         Chout_asc = Chout(i) + 55                ' in Ascii Buchstaben wandeln
      Else
         Chout_asc = Chout(i) + 48                ' in Ascii Zahl wandeln
      End If
      Chout_disp = Chr(chout_asc)                 ' in Char wandeln

      Lcd Chout_disp
      Locate Z , I
      Gosub 256Vorschau                           ' "Vorschau" auf Ausgang 16
      Gosub 256bitausgabe0                        ' update abhngig von Cursorposition
   End If
   Minus = 0                                      ' Flag zurcksetzen
Return

'*************************************************************************
'* In/Out toggeln (fr Handbetrieb per Encoder)
'*************************************************************************
Einaus:
   Toggle Inout
   If Inout = 0 Then
      Z = 2
      Gosub 256bitausgabe1                         ' Matrix neu laden
   Else
      Z = 1
   End If
   Locate Z , I
Return

'***************************************************************
'* Daten ---> Matrix     (16 x 16 bit)
'***************************************************************
256bitausgabe0:                                    ' Matrix NICHT laden wenn Cursor auf Eingabekanal
   If Z = 1 Then Goto Raus1
256bitausgabe1:                                    ' Matrix immer laden unabhngig von Cursorposition
   Dim zz as  Byte
   Dim j  as  Byte
   Strb = 0
   For N = Xmalx To 1 Step -1                      ' "hinterste" zuerst
      zz = Chout(N) - 1
      Outdat = 2^zz
      If Xmalx = 8 Then
         Zz = Low(outdat)
         Shiftout Dat , Clk , Zz , 1               ' 1 = MSB first when clock high
      Else
         Shiftout Dat , Clk , Outdat , 1           ' 1 = MSB first when clock high
      End If
   Next N

   Strb = 1
   Waitus 10                                        ' Delay             ' ca. 10 us
   Strb = 0
Raus1:
Return
'***************************************************************
'* Vorschau ---> Matrix   auf 8/16
'***************************************************************
256Vorschau:
   Strb = 0
'Vorschau bergeben
   zz = Chout(i) - 1
   Outdat = 2^zz
   If Xmalx = 8 Then
      Zz = Low(outdat)
      Shiftout Dat , Clk , Zz , 1                        ' 1 = MSB first when clock high
   Else
      Shiftout Dat , Clk , Outdat , 1                    ' 1 = MSB first when clock high
   End If
'Rest nachziehen
   For N = xmalx - 1 To 1 Step -1                           ' "hinterste" zuerst
      zz = Chout(N) - 1
      Outdat = 2^zz
      If Xmalx = 8 Then
         Zz = Low(outdat)
         Shiftout Dat , Clk , Zz , 1                        ' 1 = MSB first when clock high
      Else
         Shiftout Dat , Clk , Outdat , 1                    ' 1 = MSB first when clock high
      End If
   Next N

   Strb = 1
   Waitus 10                                                'Delay             ' ca. 10 us
   Strb = 0
Return


'********************************************************************
'* Update 1. Zeile (Input)
'********************************************************************
Erste_zeile:
   Locate 1 , 1                                   ' Cursor in die erste Zeile

   For N = 1 To Xmalx
      If Chout(n) > 9 Then
         Chout_asc = Chout(n) + 55                ' in Ascii Buchstaben wandeln
      Else
         Chout_asc = Chout(n) + 48                ' in Ascii Zahl wandeln
      End If
      Chout_disp = Chr(chout_asc)                 ' in Char wandeln
      Lcd Chout_disp                              ' ... und in 1.Zeile ausgeben
      'Waitms 50                                  ' warum Wait? LCD zu langsam ?
   Next N
   Locate 2 , I                                   ' Cursor in 2te Zeile
Return

'*********************************************************************
' VMuster als Standard in EEProm speichern
'*********************************************************************
Standard_speichern:
   For I = 1 To 16
      Writeeeprom Chout(i) , I                    '
   Next I
   I = 1                                          ' Cursor wieder Position 1
Return

'**********************************************************************
' Standardkonfigurationen aus EEProm laden
'**********************************************************************
Standard_laden:                                   ' aus EEPROM
   For I = 1 To 16                                ' Var aus Data
      Readeeprom Chout(i) , I
   Next I
   I = 1                                          ' Cursor wieder Position 1
Return

'*************************************************************************
'* Interrupt Services
'*************************************************************************
Isr0:                                             ' Encoder Auswertung
   If Pind.2 = Updown Then
      If Drehrichtung.0 = 0 Then
         Plus = 1
      Else
         Minus = 1                                ' Flag setzen
      End If
   Else
      If Drehrichtung.0 = 0 Then
         Minus = 1
      Else
         Plus = 1
      End If                                      ' Flag setzen
   End If
Return

'------------------------------------
Twi_gotdata:                                      ' Daten vom Master: 3 Bytes (Befehle) oder 17 Bytes (Muster) kommen rein
   Masterbyte = Twi                               ' neue Daten merken

   If Masterbyte > 64 And Masterbyte < 128 Then   ' wegen * und # (128 und 129)
      V = Masterbyte - 64
   Else
      If Byte_count = 0 Then
         Chin = Masterbyte                        '
         Byte_count = 1
      Elseif Byte_count = 1 Then
         I = Masterbyte
         Byte_count = 2
         Chout(i) = Chin
      Elseif Byte_count = 2 Then
         Schalter = Masterbyte
         Byte_count = 0
         Neue_daten = 1                           ' 3 neue bytes vom Master empfangen
      End If
   End If
Return
'---------------------------------------------------------------------------------
Twi_master_needs_byte:                            ' Master fragt Daten ab
   Twi = Chout(v)                                 ' entweder 16 bytes (=alle Koppelpunkte mit v = 1)...
   V = V + 1                                      ' ...oder 1 byte (= Koppelpunkt v)
Return

'------------------------------ mssen im Quelltext sein (nicht benutzt) ---------------
Twi_stop_rstart_received:
   nop
Return
Twi_addressed_goread:
   nop
Return
Twi_addressed_gowrite:
   nop
Return
Twi_master_need_nomore_byte:
   nop
Return
